#ifndef KTNEFATTACH_H
#define	KTNEFATTACH_H

#include <qstring.h>

class KTNEFAttach
{
public:
	enum ParseState { Unparsed = 0x0000, TitleParsed = 0x0001, DataParsed = 0x0002, InfoParsed = 0x0004};

	KTNEFAttach() : state_(Unparsed), offset_(-1), size_(0), displaysize_(0), name_(""), index_(-1), filename_(""), displayname_(""), mimetag_(""), extension_("") {}

	void setTitleParsed() { state_ |= TitleParsed; }
	void setDataParsed() { state_ |= DataParsed; }
	void setInfoParsed() { state_ |= InfoParsed; }
	bool titleParsed() const { return (state_ & TitleParsed); }
	bool dataParsed() const { return (state_ & DataParsed); }
	bool infoParsed() const { return (state_ & InfoParsed); }
	bool checkState(int state) const { return (state_ & state); }

	int offset() const { return offset_; }
	void setOffset(int n) { setDataParsed(); offset_ = n; }
	int size() const { return size_; }
	void setSize(int s) { size_ = s; }
	int displaySize() const { return displaysize_; }
	void setDisplaySize(int s) { displaysize_ = s; }
	QString name() const { return name_; }
	void setName(const QString& str) { setTitleParsed(); name_ = str; }
	int index() const { return index_; }
	void setIndex(int i) { setInfoParsed(); index_ = i; }
	QString fileName() const { return filename_; }
	void setFileName(const QString& str) { filename_ = str; }
	QString displayName() const { return displayname_; }
	void setDisplayName(const QString& str) { displayname_ = str; }
	QString mimeTag() const { return mimetag_; }
	void setMimeTag(const QString& str) { mimetag_ = str; }
	QString extension() const { return extension_; }
	void setExtension(const QString& str) { extension_ = str; }

private:
	int	state_;

	int	offset_;
	int	size_;
	int	displaysize_;
	QString	name_;
	int	index_;
	QString	filename_;
	QString	displayname_;
	QString	mimetag_;
	QString	extension_;
};

#endif
