#ifndef KTNEFPARSER_H
#define	KTNEFPARSER_H

#include <qdatastream.h>
#include <qcstring.h>
#include <qfile.h>
#include <qlist.h>
#include <qstring.h>
#include <qstrlist.h>

class KTNEFAttach;
struct KTNEFAttribute;

class KTNEFParser
{
public:
	KTNEFParser();
	~KTNEFParser();

	bool openFile(const QString& filename);
	const QList<KTNEFAttach>& attachmentList() const { return attachments_; }
	bool extractFile(const QString& filename);
	bool extractFileTo(const QString& filename, const QString& dirname);
	bool extractAll();
	void setDefaultExtractDir(const QString& dirname);
	KTNEFAttach* getAttachment(const QString& filename);

private:
	bool decodeAttachment();
	bool decodeMessage();
	bool extractAttachmentTo(KTNEFAttach *att, const QString& dirname);
	bool parseFile(const QString& filename);
	void checkCurrent(int state);
	bool decodeAttachmentInfo(QByteArray *buf);

private:
	QDataStream	stream_;
	QFile		file_;
	QList<KTNEFAttach>	attachments_;
	QString		defaultdir_;
	KTNEFAttach	*current_;
	QString		filename_;
};

#endif
